/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* balanc.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int balanc_ (nm, n, a, low, igh, scale)
     integer *nm, *n;
     doublereal *a;
     integer *low, *igh;
     doublereal *scale;
{
   /* System generated locals */
   integer a_dim1, a_offset, i__1, i__2;
   doublereal d__1;

   /* Local variables */
   static integer iexc;
   static doublereal c__, f, g;
   static integer i__, j, k, l, m;
   static doublereal r__, s, radix, b2;
   static integer jj;
   static logical noconv;

/* ***BEGIN PROLOGUE  BALANC */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C1A */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Balances a general DOUBLE PRECISION matrix and isolates eigenvalue */
/*            whenever possible. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure BALANCE, */
/*     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch. */
/*     HANDBOOk FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971). */

/*     This subroutine balances a DOUBLE PRECISION matrix and isolates */
/*     eigenvalues whenever possible. */

/*     On INPUT */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        A contains the input matrix to be balanced. */

/*     On OUTPUT */

/*        A contains the balanced matrix. */

/*        LOW and IGH are two integers such that A(I,J) */
/*          is equal to zero if */
/*           (1) I is greater than J and */
/*           (2) J=1,...,LOW-1 or I=IGH+1,...,N. */

/*        SCALE contains information determining the */
/*           permutations and scaling factors used. */

/*     Suppose that the principal submatrix in rows LOW through IGH */
/*     has been balanced, that P(J) denotes the index interchanged */
/*     with J during the permutation step, and that the elements */
/*     of the diagonal matrix used are denoted by D(I,J).  Then */
/*        SCALE(J) = P(J),    for J = 1,...,LOW-1 */
/*                 = D(J,J),      J = LOW,...,IGH */
/*                 = P(J)         J = IGH+1,...,N. */
/*     The order in which the interchanges are made is N to IGH+1, */
/*     then 1 TO LOW-1. */

/*     Note that 1 is returned for IGH if IGH is zero formally. */

/*     The ALGOL procedure EXC contained in BALANCE appears in */
/*     BALANC  in line.  (Note that the ALGOL roles of identifiers */
/*     K,L have been reversed.) */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  BALANC */

/* ***FIRST EXECUTABLE STATEMENT  BALANC */
   /* Parameter adjustments */
   --scale;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   radix = 16.;

   b2 = radix * radix;
   k = 1;
   l = *n;
   goto L100;
/*     .......... IN-LINE PROCEDURE FOR ROW AND */
/*                COLUMN EXCHANGE .......... */
 L20:
   scale[m] = (doublereal) j;
   if (j == m)
   {
      goto L50;
   }

   i__1 = l;
   for (i__ = 1; i__ <= i__1; ++i__)
   {
      f = a[i__ + j * a_dim1];
      a[i__ + j * a_dim1] = a[i__ + m * a_dim1];
      a[i__ + m * a_dim1] = f;
/* L30: */
   }

   i__1 = *n;
   for (i__ = k; i__ <= i__1; ++i__)
   {
      f = a[j + i__ * a_dim1];
      a[j + i__ * a_dim1] = a[m + i__ * a_dim1];
      a[m + i__ * a_dim1] = f;
/* L40: */
   }

 L50:
   switch ((int) iexc)
   {
       case 1:
          goto L80;
       case 2:
          goto L130;
   }
/*     .......... SEARCH FOR ROWS ISOLATING AN EIGENVALUE */
/*                AND PUSH THEM DOWN .......... */
 L80:
   if (l == 1)
   {
      goto L280;
   }
   --l;
/*     .......... FOR J=L STEP -1 UNTIL 1 DO -- .......... */
 L100:
   i__1 = l;
   for (jj = 1; jj <= i__1; ++jj)
   {
      j = l + 1 - jj;

      i__2 = l;
      for (i__ = 1; i__ <= i__2; ++i__)
      {
         if (i__ == j)
         {
            goto L110;
         }
         if (a[j + i__ * a_dim1] != 0.)
         {
            goto L120;
         }
       L110:
         ;
      }

      m = l;
      iexc = 1;
      goto L20;
    L120:
      ;
   }

   goto L140;
/*     .......... SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE */
/*                AND PUSH THEM LEFT .......... */
 L130:
   ++k;

 L140:
   i__1 = l;
   for (j = k; j <= i__1; ++j)
   {

      i__2 = l;
      for (i__ = k; i__ <= i__2; ++i__)
      {
         if (i__ == j)
         {
            goto L150;
         }
         if (a[i__ + j * a_dim1] != 0.)
         {
            goto L170;
         }
       L150:
         ;
      }

      m = k;
      iexc = 2;
      goto L20;
    L170:
      ;
   }
/*     .......... NOW BALANCE THE SUBMATRIX IN ROWS K TO L .......... */
   i__1 = l;
   for (i__ = k; i__ <= i__1; ++i__)
   {
/* L180: */
      scale[i__] = 1.;
   }
/*     .......... ITERATIVE LOOP FOR NORM REDUCTION .......... */
 L190:
   noconv = FALSE_;

   i__1 = l;
   for (i__ = k; i__ <= i__1; ++i__)
   {
      c__ = 0.;
      r__ = 0.;

      i__2 = l;
      for (j = k; j <= i__2; ++j)
      {
         if (j == i__)
         {
            goto L200;
         }
         c__ += (d__1 = a[j + i__ * a_dim1], abs (d__1));
         r__ += (d__1 = a[i__ + j * a_dim1], abs (d__1));
       L200:
         ;
      }
/*     .......... GUARD AGAINST ZERO C OR R DUE TO UNDERFLOW .......... */
      if (c__ == 0. || r__ == 0.)
      {
         goto L270;
      }
      g = r__ / radix;
      f = 1.;
      s = c__ + r__;
    L210:
      if (c__ >= g)
      {
         goto L220;
      }
      f *= radix;
      c__ *= b2;
      goto L210;
    L220:
      g = r__ * radix;
    L230:
      if (c__ < g)
      {
         goto L240;
      }
      f /= radix;
      c__ /= b2;
      goto L230;
/*     .......... NOW BALANCE .......... */
    L240:
      if ((c__ + r__) / f >= s * .95)
      {
         goto L270;
      }
      g = 1. / f;
      scale[i__] *= f;
      noconv = TRUE_;

      i__2 = *n;
      for (j = k; j <= i__2; ++j)
      {
/* L250: */
         a[i__ + j * a_dim1] *= g;
      }

      i__2 = l;
      for (j = 1; j <= i__2; ++j)
      {
/* L260: */
         a[j + i__ * a_dim1] *= f;
      }

    L270:
      ;
   }

   if (noconv)
   {
      goto L190;
   }

 L280:
   *low = k;
   *igh = l;
   return 0;
}                                       /* balanc_ */
