/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       autozyg.h:  Header file for lm_auto, lm_pval, lm_ibdtests     */
/*                        and lm_map.                                  */
/*                    Contains #includes for header files for          */
/*                        libraries used                               */
/*                    and #defines, typedefs, variables and            */
/*                        function prototypes.                         */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef AUTOZYG_H
#define AUTOZYG_H

#define DEFINE_DATA

#include "parsie.h"
#include "nghds.h"
#include "pedchk.h"
#include "msample.h"
#include "lsample.h"
#include "quantset.h"
#include "rans.h"
#include "traits.h"

#ifdef AUTO_DISP
#include "gldisp.h"
#endif

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @defgroup autozyg Autozyg programs.
 * @ingroup Programs
 * @{
 */

struct _cleanup clean_auto[] = {
{"avtq", free_fnams},
{"avtq", freeChkPed},
{"avtq", freeKey},
{"avtq", free_auto},
{"avtq", free_marek},
{"avtq", free_locnams},
{"avtq", free_ped},
{"avtq", free_nghds},
{"avtq", free_cmplists},
{"avtq", free_xxgg},
{"avtq", free_switches},
{"avtq", free_allefrq},
{"avtq", locus_peel_free},
{"avtq", free_allocate_loci},
{"avtq", free_msmpl},
{"a   ", free_sampling_cmp},
{"avt ", free_trait_pars},
{"avtq", free_traits},
{"a   ", free_gen_pen},
{"a   ", free_exact},
{"a   ", free_dub},
{""  , NULL}};

/** @} */

#endif /*AUTOZYG_H*/

