/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/**
 * @file   pedcomp.h
 * @author Myrna Jewett
 * @date   Wed Sep  4 22:24:24 2002
 *
 * @brief  header file for PedComp/ pedcheck and kin.
 *
 * Includes header files for libraries used.
 *
 * \$Id: pedcomp.h,v 1.9.2.2 2012/12/06 21:00:07 slewis Exp $
 */

#ifndef PEDCOMP_H
#define PEDCOMP_H

#define DEFINE_DATA

#include "parsie.h"
#include "pedchk.h"
#include "nghds.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @addtogroup PedComp PedComp programs.
 * @ingroup Programs
 * @{
 */

void  set_kinix (int);
void  free_kin (void);

static struct _cleanup clean_check[] = {
{"pk", free_fnams},
{"pk", freeChkPed},
{"pk", freeKey},
{" k", free_cmplists},
{" k", free_auto},
{" k", free_ped},
{" k", free_nghds},
{" k", free_kin},
{" k", free_dub},
{""  , NULL}};

/** @} */

#endif /*PEDCOMP_H*/
