/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*                rans.h:  header file for Rans/                        */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef RANS_H
#define RANS_H

/**
 * @defgroup rans librans
 * @ingroup Libraries
 * @{
 */

/* Definition of uint32 (32 bit unsigned integer type) moved to globs.h */

#include "incs.h"

#define CONGRUENTIAL_SEED 12345u        /* default seed values          */
#define TAUSWORTHE_SEED   1073u         /* (see rans.c)                 */

enum {MARK, TRAIT, SAMPL, PERM};        /* seed types for mSeeds.c      */

double rans(void);
double rexp(double);
double normal(double, double);
int intran(int, int);
void setsd(uint32, uint32);
void getsd(uint32 *, uint32 *);
void get_seeds(const char *fname);
void put_seeds(const char *fname);
int rand_int(double *work, int k );
void permute(int *ab, int n);
int getranscount(void);

void setSeeds(int);
void getSeeds(int);
void assgnSeeds(int);
void writSeeds(FILE *);

/** @} */

#endif  /*RANS_H*/

