/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "markers.h"

/**
 *  set observed marker and trait genotypic data for pedigree members.
 */
void setObsDat (void)
{
   /* set marker data, and trait data if genotypic, for observed individuals: 
    *                                        nghd[].g_dat[2*(NMarks+1)]  */
   set_markdat (NMarks, nCompnt);

   /* if trait data is discrete, set trait data from pedigree data   
    *                                        nghd[].d_dat[2*(NMarks+1)]  */
   if (TraitTyp == GENOTYPIC || TraitTyp == DISCRETE)
   {
      if (PedDatTyp != DISCR_LIAB && PedDatTyp != DISCR_COVAR)
         set_traitdat (pedsize, nCompnt, 1);
      else
         set_traitdat (pedsize, nCompnt, 2);
      prnt_traitdat (pedsize, nCompnt);

      if (IS_LM_PVAL)
         set_affind (nCompnt, 1);       /* sets only affecteds  */
      else if (IS_LM_IBDTESTS)
         set_affind (nCompnt, 0);       /* sets affecteds & unaffecteds */
   }
   if (DebugMain)
      dbgGDat ();

   return;
}
