/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/* --------------- proc_err:  Called by MORGAN programs.  ----------------------
 *                            Prints warning or error messages.
 *                            Error codes and messages are in errspars.h.
 *
 *                                                              MAJ Jun 1997
 */

int proc_err (void)
{
   int   i;

   fflush (stdout);

   perr = proc_errors + (int) err_typ;
   if (perr->level == 'W')
      ++n_warn;
   else if (perr->level == 'E')
      ++n_err;

   if (perr->tokflg)                    /* Tokens are printed if known.       */
   {
      fprintf (stderr, "### ");
      for (i = 0; token[i][0] != NUL; ++i)
         fprintf (stderr, "%s ", token[i]);
      fprintf (stderr, "\n\n   ");
   }

   if (perr->txtflg)                    /* Warning or error is printed.       */
      fprintf (stderr, perr->msg, err_txt);
   else
      fprintf (stderr, "%s", perr->msg);

   fprintf (stderr, "  (%c)\n\n", perr->level);

   if (perr->statflg && !prntd_flg)     /* Correct statement form printed.    */
   {
      fprintf (stderr, "    Correct form is:  %s\n\n",
               input_statement[key_ix - 1]);
      prntd_flg = Y;
   }

   fflush (stderr);

   if (perr->level == 'Q')              /* Tests for "quit".                  */
      return TRUE;

   if (perr->level == 'F')              /* Tests for fatal errors.            */
   {
      err_typ = ERR_FAT;
      if (proc_err ())
         return TRUE;
   }

   if (n_err + n_warn >= MAX_PERR)      /* Tests for too many errors.         */
   {
      err_typ = ERR_MAX;
      if (proc_err ())
         return TRUE;
   }
   err_typ = 0;

   return FALSE;
}
