/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#define PNAM "pedcheck"
#include "pedcomp.h"

/**
 * @defgroup pedcheck pedcheck
 * @ingroup PedComp
 * @{
 */

int main (int argc, char *argv[])
{
   atexit (print_tail);

   PCleanUp = clean_check;
   atexit (clean_morg);

   print_head (*argv);

   if (!proc_pars (argc, argv, PNAM))   /* Process parameter statements.      */
      exit (EXIT_FAILURE);

   if (!proc_fils ())                   /* Set up pedigree file parameters.   */
      exit (EXIT_FAILURE);

   if (!chk_pedfil ())                  /* Reads pedigree file and checks     */
      give_up (ERR_qit);                /* pedigree for errors.               */

   if (!ChronOut)                       /* If output file is to be in input   */
      sortIx ();                        /* order, resort it.                  */

   if (!mak_opedfil ())                 /* Writes output pedigree file, if    */
      give_up (ERR_qit);                /* there are any changes to the file. */

   if (!mak_oindfil ())                 /* Writes output individuals file, if */
      give_up (ERR_qit);                /* one has been named by the user.    */

   exit (EXIT_SUCCESS);
}

/** @} */
