/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "markers.h"

void dbgXXGG (void)
{
   int   m_origin;
   int   i_ndx;
   int   m1;

   m_origin = max (NTLocs, 1);          /* Subscript to the first marker.     */

   for (m1 = m_origin; m1 < NLoci; ++m1)
   {
      fprintf (stderr, "Locus %d position %d set-up\n", m1, chromo[0][m1]);
      for (i_ndx = 0; i_ndx < pedsize; ++i_ndx)
      {
         fprintf (stderr, " %3d %*s", i_ndx, widPNam, nghd[i_ndx].self);
         fprintf (stderr, "  %*s  %*s", widPNam, nghd[i_ndx].pa->self,
                  widPNam, nghd[i_ndx].ma->self);
         fprintf (stderr, "   %2d  %2d   %2d  %2d\n", xx1[m1][i_ndx],
                  xx0[m1][i_ndx], gg1[m1][i_ndx], gg0[m1][i_ndx]);
      }
      fprintf (stderr, "\n");
      fflush (stderr);
   }

   return;
}

void dbgGDatGG (int m1)
{
   int   i_ndx;
   int   i1;

   for (i1 = 0; i1 < NObs; ++i1)
   {
      i_ndx = ObsIx[i1];
      if (i_ndx != INVALID_INDEX)
      {
         fprintf (stderr, "   %2d %*s %2d   %2d %2d   %2d %2d\n", i1,
                  widPNam, nghd[i_ndx].self, i_ndx, gg1[m1][i_ndx],
                  gg0[m1][i_ndx], nghd[i_ndx].g_dat[2 * m1],
                  nghd[i_ndx].g_dat[2 * m1 + 1]);
      }
   }
   fprintf (stderr, "\n");
   fflush (stderr);

   return;
}

void dbgProb (double **prob)
{
   int   m_origin;
   int   comp_no;
   int   m1;

   m_origin = max (NTLocs, 1);          /* Subscript to the first marker.     */

   for (m1 = m_origin; m1 < NLoci; ++m1)
   {
      fprintf (stderr, " Set genes at locus %d:\n", m1);
      dbgGDatGG (m1);
   }
   fprintf (stderr, "\n");

   for (m1 = m_origin; m1 < NLoci; ++m1)
   {
      fprintf (stderr, " Computed probabilities at locus %d:\n", m1);
      for (comp_no = 0; comp_no < nCompnt; ++comp_no)
         fprintf (stderr, "   For component %d:  %6.4f\n",
                  comp_no, prob[comp_no][m1]);
   }
   fprintf (stderr, "\n");
   fflush (stderr);

   return;
}
