/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "lsample.h"
#include "msample.h"

/* Sets up data structures for locus sampling.                                */

void setSampling (void)
{
   int   pen_flag;                      /* Penetrance flag.                   */

   /* Allocate arrays xx0, xx1 for meiosis indicators.
    *                                        int xx0 [NLoci][PedSize]
    *                                            xx1 [NLoci][PedSize]
    * Allocate arrays gg0, gg1 for genes.
    *                                            gg0 [NLoci][PedSize]
    *                                            gg1 [NLoci][PedSize]         */
   alloc_xxgg (NLoci, pedsize);         /* Bug Fix; EAT Apr 2010              */
   /* Note pedsize is number of individuals read; may be less than PedSize    */

   /* Allocate the global locus structure.
    *                                            struct Locus loci[NLoci]     */
   if (TraitTyp == QUANTITATIVE)
      pen_flag = 4;
   else if (PedDatTyp == DISCR_LIAB)
      pen_flag = 3;
   else if (PedDatTyp == DISCR_COVAR)
      pen_flag = 5;
   else
      pen_flag = 1;

   allocate_loci (pen_flag);

   /* NOTE: trait values for quantitative trait are no longer centered
    *  EAT 8/2004   */
   /* Set quantitative trait locus model.
    *                                            struct Locus loci[NLoci]     */
   if (TraitTyp == QUANTITATIVE && GxGInteraction == FALSE)
      set_quant_trait ();

   /* Do any initialization required for the penetrance functions.            */
   if (loci[0].penetrance == qtlpen)
      set_qtlpen (loci[0].ve);
   else if (loci[0].penetrance == logisticpen)
      set_logistic ();

   return;
}

/* Sets up data structures for meiosis sampling.                              */

void setMSampling (void)
{
   /* Allocate working arrays used by do_msmpl(), for inheritance indicators, */
   /* penetrance probabilities at each locus and cumulative peeling           */
   /* probabilities along the chromosome.                                     */

   alloc_msmpl ();

   return;
}
