/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "stuff.h"

/* function for comparing doubles by qsort  */

int qfunc_doub (const void *d1, const void *d2)
{
   double t1, t2;

   t1 = *(const double *) d1;
   t2 = *(const double *) d2;

   return (t1 < t2) ? -1 : (t1 > t2) ? 1 : 0;
}

/* function for comparing doubles by qsort  */
/* for decreasing order sort                */

int qfunc_doubdec (const void *d1, const void *d2)
{
   double t1, t2;

   t1 = *(const double *) d1;
   t2 = *(const double *) d2;

   return (t1 < t2) ? 1 : (t1 > t2) ? -1 : 0;
}

/* function for comparing integers by qsort  */

int qfunc_int (const void *s1, const void *s2)
{
   int   i1, i2;

   i1 = *(const int *) s1;
   i2 = *(const int *) s2;

   if (i1 < i2)
      return -1;
   if (i2 < i1)
      return 1;
   return 0;
}
